'use strict';

module.exports = {
  "env": {
    "es6": true,
    "node": true
  },
  "rules": {
    "array-bracket-spacing": [ "error", "always" ],
    "brace-style": [ "error", "stroustrup", { "allowSingleLine": true } ],
    "comma-dangle": [ "error", { "objects": "ignore", "arrays": "ignore" } ],
    "curly": [ "error" ],
    "default-case": "error",
    "default-case-last": "error",
    "default-param-last": "error",
    "eol-last": "warn",
    "eqeqeq": "warn",
    "for-direction": "off",
    "init-declarations": "error",
    "key-spacing": "error",
    "keyword-spacing": "error",
    "max-classes-per-file": "error",
    "max-len": [ "warn", { "code": 140, "ignoreTrailingComments": true, "ignoreUrls": true, "ignoreTemplateLiterals": true, "ignoreStrings": true } ],
    "max-nested-callbacks": [ "error", { "max": 4 }],
    "max-statements-per-line": [ "error", { "max": 2 } ],
    "new-cap": "warn",
    "no-console": "off",
    "no-floating-decimal": "error",
    "no-magic-numbers": "off",
    "no-multi-spaces": "error",
    "no-multi-str": "error",
    "no-multiple-empty-lines": ["error", { "max": 2 }],
    "no-promise-executor-return": "error",
    "no-return-assign": "error",
    "no-return-await": "error",
    "no-sequences": "error",
    "no-throw-literal": "error",
    "no-unreachable": "error",
    "no-unused-vars": "error",
    "no-useless-catch": "error",
    "no-useless-constructor": "off",
    "no-useless-return": "error",
    "no-var": "error",
    "no-warning-comments": "warn",
    "padded-blocks": "off",
    "prefer-const": "error",
    "prefer-promise-reject-errors": "off",
    "quotes": [ "warn", "single" ],
    "quote-props": [ "error", "consistent-as-needed" ],
    "radix": "error",
    "require-await": "error",
    "semi": ["warn", "always" ],
    "space-before-function-paren": "off",
    "spaced-comment": [ "warn", "always", { "exceptions": [ "*", "/" ], "markers": [ "#region", "#endregion" ] } ],
    "sort-keys": "off",
    "space-before-blocks": "error",
    "strict": "warn",
    "wrap-iife": "error",
    "yoda": ["error", "never", { "exceptRange": true }],

    "unicorn/no-null": "off",
    "unicorn/prefer-number-properties": "off",
    "unicorn/prevent-abbreviations": "off",

    "@typescript-eslint/no-explicit-any": [ "warn", { "ignoreRestArgs": true } ],
    "@typescript-eslint/no-useless-constructor": "error"
  }
};
